{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% if object %}{% trans "Editing" %} {{ object.user.get_full_name }}{% else %}{% trans "Add new senior" %}{% endif %}{% endblock %}
{% block extrahead %}
<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
{% endblock %}
{% block content %}

<div class="page-header mb-4">
    <h1>{% if object %}{% trans "Editing" %} {{ object.user.get_full_name }}{% else %}{% trans "Add new senior" %}{% endif %}</h1>
</div>

<div class="row">
    <div class="col-lg-4">
        {{ form.errors }}
        <form action="" method="post">
            {% csrf_token %} {{ form.next_url }} {{ form.home_address_parts }}
            <div class="form-group mb-3">
                {{ form.last_name.errors }}
                {{ form.last_name.label_tag }} {{ form.last_name }}
            </div>
            <div class="form-group mb-3">
                {{ form.first_name.errors }}
                {{ form.first_name.label_tag }} {{ form.first_name }}
            </div>
            <div class="form-group mb-3">
                {{ form.yob.errors }}
                {{ form.yob.label_tag }} {{ form.yob }}
            </div>
            <div class="form-group mb-3">
                {{ form.email.errors }}
                {{ form.email.label_tag }} {{ form.email }}
            </div>
            <div class="form-group mb-3">
                {{ form.phone_number.errors }}
                {{ form.phone_number.label_tag }} {{ form.phone_number }}
            </div>
            <div class="form-group mb-3">
                {{ form.home_address.label_tag }}
                <select name="home_address" id="id_home_address" class="form-control">
                    {% if form.home_address.value %}<option value="{{ form.home_address.value }}" selected>{{ form.home_address.value }}</option>{% endif %}
                </select>
            </div>
            <div class="row mb-3">
                <div class="col-lg-6">
                    {{ form.home_address_lat }}
                </div>
                <div class="col-lg-6">
                    {{ form.home_address_lng }}
                </div>
            </div>
            <div class="form-group mb-3">
                {{ form.contact_sms.errors }}
                {{ form.contact_sms.label_tag }} {{ form.contact_sms }}
                <br><i>{{ form.contact_sms.help_text }}</i>
            </div>
            <div class="form-group mb-3">
                {{ form.contact_email.errors }}
                {{ form.contact_email.label_tag }} {{ form.contact_email }}
            </div>
            <div class="form-group mb-3">
                {{ form.language.errors }}
                {{ form.language.label_tag }} {{ form.language }}
            </div>
            <div class="form-group mb-3">
                {{ form.member_card_issuer.errors }}
                {{ form.member_card_issuer.label_tag }} {{ form.member_card_issuer }}
            </div>
            <div class="form-group mb-3">
                {{ form.member_card_number.errors }}
                {{ form.member_card_number.label_tag }} {{ form.member_card_number }}
            </div>
            <div class="form-group mb-3">
                {{ form.notes.errors }}
                {{ form.notes.label_tag }} {{ form.notes }}
            </div>
            <div class="mt-4 text-end">
                <button role="button" type="submit" class="btn btn-lg btn-success">
                    <i class="fas fa-save"></i> &nbsp; {% trans "Save" %}
                </button>
            </div>
        </form>
    </div>
    <div class="col-lg-8">
        <div id="map" style="height: 600px;"></div>
        <p id="map-navigation-keys-hint" class="text-end mx-3 my-2"><kbd>Ctrl</kbd>&nbsp;+&nbsp;<kbd>Alt</kbd> {% trans "to navigate the map using the mouse." %}</p>
        {% if object %}
            <div class="mt-5 ps-4 border-start border-dark">
                <h2 class="h2 mt-3 mb-4">{% trans "Trips log" %}</h2>
                <table class="table" id="trips_log_table">
                    <thead>
                        <tr>
                            <th>{% trans "Date and time" %}</th>
                            <th>{% trans "From" %}</th>
                            <th>{% trans "To" %}</th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for i in object.reservation_set.all %}
                            {% for j in i.tripleg_set.all %}
                                <tr>
                                    <td data-order="{{  j.start.estimated_be_at.timestamp }}">{{ j.start.estimated_be_at }}</td>
                                    <td>{{ j.start.location.get_print_address }}</td>
                                    <td>{{ j.end.location.get_print_address }}</td>
                                    <td>
                                        <a href="{% url 'operators:new-reservation-from-trip-leg' tlid=j.pk %}" class="btn btn-primary">
                                            <i class="fas fa-copy"></i>
                                        </a>
                                        <a href="{% url 'operators:edit-reservation' pk=i.pk %}" class="btn btn-success">
                                            <i class="fas fa-arrow-right"></i>
                                        </a>
                                    </td>
                                </tr>
                            {% endfor %}
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        {% endif %}
    </div>
</div>

<script type="text/javascript">
    $(document).ready(function() {
        var disableMapInteraction = function(map) {
            map.dragging.disable();
            map.touchZoom.disable();
            map.doubleClickZoom.disable();
            map.scrollWheelZoom.disable();
            map.boxZoom.disable();
            map.keyboard.disable();
            if (map.tap) {
                map.tap.disable();
            }
        };

        var enableMapInteraction = function(map) {
            map.dragging.enable();
            map.touchZoom.enable();
            map.doubleClickZoom.enable();
            map.scrollWheelZoom.enable();
            map.boxZoom.enable();
            map.keyboard.enable();
            if (map.tap) {
                map.tap.enable();
            }
        };

        $('#id_yob').select2();
        $('#id_member_card_issuer').select2();

        {% if object %}
        $("#trips_log_table").dataTable({
            language: {url: "{% static 'datatables1/i18n/'|add:LANGUAGE_CODE|add:"_"|add:LANGUAGE_CODE|add:'.json' %}"},
            pageLength: 5,
            lengthMenu: [5, 10, 15, 20, 30, 50]
        });
        {% endif %}

        // map configuration
        window.map = L.map('map').setView({{ MAP_DEFAULT_VIEW|safe }}, 13);
        window.layergroup = L.layerGroup().addTo(window.map);
        var tiles = L.tileLayer('//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 18,
            minZoom: 2,
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(window.map);
        {% if form.home_address.value %}
            L.marker([{{ form.home_address_lat.value|safe }}, {{ form.home_address_lng.value|safe }}]).addTo(window.layergroup);
            window.map.setView([{{ form.home_address_lat.value|safe }}, {{ form.home_address_lng.value|safe }}], 15);
        {% endif %}

        // address search via OSM Nominatim
        $('#id_home_address').select2({
            ajax: {
                url: "{% url 'addresses-ajax-search' %}",
                dataType: "json",
                delay: 400,
                type: "POST",
                data: function (params) {return {"q": params.term, "csrfmiddlewaretoken": "{{ csrf_token }}"};},
                processResults: function (data, params) {return {results: data}}
            },
            placeholder: "{% trans 'Start typing the address' %}",
            minimumInputLength: 6,
            templateResult: function (address) {return address.display_name || "{% trans 'Searching...' %}";}
        }).on("select2:select", function (e) {
            window.address = e.params.data;
            window.layergroup.clearLayers();
            L.marker([window.address.lat, window.address.lon]).addTo(window.layergroup);
            window.map.setView([window.address.lat, window.address.lon]);
            $("#id_home_address_lat").val(window.address.lat);
            $("#id_home_address_lng").val(window.address.lon);
            $("#id_home_address_parts").val(JSON.stringify(window.address.address));
        });

        // setup map interaction with ctrl+alt key combination
        if (!Modernizr.touchevents) {
            disableMapInteraction(window.map);
            window.map.on('keydown', function (evt) {
                if (evt.originalEvent.ctrlKey && evt.originalEvent.which === 18) {
                    evt.originalEvent.preventDefault();
                    enableMapInteraction(window.map);
                }
            });
            window.map.on('keyup', function (evt) {
                if (evt.originalEvent.which === 18) {
                    evt.originalEvent.preventDefault();
                    disableMapInteraction(window.map);
                }
            });
            document.addEventListener('keydown', function (evt) {
                if (evt.ctrlKey && evt.which === 18) {
                    evt.preventDefault();
                    enableMapInteraction(window.map);
                }
            });
            document.addEventListener('keyup', function (evt) {
                if (evt.which === 18) {
                    evt.preventDefault();
                    disableMapInteraction(window.map);
                }
            });
        } else {
            $('#map-navigation-keys-hint').hide();
        }
    });
</script>
<script src="{% static 'modernizr3-touchevents/touchevents.js' %}"></script>
<link rel="stylesheet" type="text/css" href="{% static 'datatables1/datatables.min.css' %}"/>
<script type="text/javascript" src="{% static 'datatables1/datatables.min.js' %}"></script>
{% endblock %}